(function() {
    /**************************************
     * Media
     **************************************/
    var player = null;
    var recorder = null;

    /*
     * 再生開始
     */
    createMediaPlayer = function() {
        //オブジェクト作成
        applican.media.createMediaPlayer("local://media/sample.mp3", function(result) {
            player = result;
            //再生終了時の処理
            player.onplaybackfinished = function() {
                player.stop();
                player.release();
                player = null;
                document.getElementById("dumpAreaPlayer").value = '再生を終了しました';
            };
            //再生開始
            player.play();
            document.getElementById('dumpAreaPlayer').value = '再生を開始しました';
        }, function() {
            //オブジェクト作成が失敗
            document.getElementById('dumpAreaPlayer').value = 'オブジェクトエラー';
        });
    };

    //再生停止
    releaseMediaPlayer = function() {
        if (player) {
            player.stop();
            player.release();
            player = null;
            document.getElementById('dumpAreaPlayer').value = '再生を停止しました';
        }
    };

    /*
     * 録音を開始
     */
    createMediaRecorder = function() {
        //ファイルシステムを取得
        applican.requestFileSystem(LocalFileSystem.PERSISTENT, 0, function(fs) {
            var recordedPath = fs.root.fullPath + "/recording_test.m4a";

            //オブジェクト作成
            applican.media.createMediaRecorder(recordedPath, function(result) {
                recorder = result;
                //録音終了時の処理
                recorder.onplaybackfinished = function() {
                    recorder.stop();
                    recorder.release();
                    recorder = null;
                    document.getElementById('dumpAreaRecorder').value = '録音を終了しました';
                };
                //録音開始
                recorder.record();
                document.getElementById('dumpAreaRecorder').value = '録音を開始しました';
            }, function() {
                //録音失敗
                document.getElementById('dumpAreaRecorder').value = '録音が失敗しました';
            });
        }, function() {
            //ファイルシステムエラー
            document.getElementById('dumpAreaRecorder').value = 'ファイルシステムエラー';
        });
    };

    //録音停止
    releaseMediaRecorder = function() {
        if (recorder) {
            recorder.stop();
            recorder.release();
            recorder = null;
            document.getElementById('dumpAreaRecorder').value = '録音を停止しました';
        }
    };

    /********************* イベント登録 *********************/
    document.addEventListener("deviceready", function() {
        // 「再生開始」ボタン押下処理
        document.getElementById("createMediaPlayer").addEventListener("touchend", createMediaPlayer, false);
        // 「再生終了」ボタン押下処理
        document.getElementById("releaseMediaPlayer").addEventListener("touchend", releaseMediaPlayer, false);
        // 「録音開始」ボタン押下処理
        document.getElementById("createMediaRecorder").addEventListener("touchend", createMediaRecorder, false);
        // 「録音終了」ボタン押下処理
        document.getElementById("releaseMediaRecorder").addEventListener("touchend", releaseMediaRecorder, false);
    }, false);
})();
